<template lang="pug">
b-card.mb-4( title="Добавить менеджера" )
	form.form( @submit.prevent='submit' )
		//- b-fields
		.is-flex.is-align-items-center.is-justify-content-flex-start
			b-field.is-flex-grow-1.mb-0( label="Имя пользователя" on-border )
				b-input( v-model='username' )
			b-field.is-flex-grow-1.mb-0.ml-2( label="Пароль" on-border )
				b-input( v-model='password' input-type="password" )
			b-field.mb-0.ml-2
				b-checkbox( v-model='root' ) Root пользователь
			b-field.ml-2
				button.button.is-primary( :class='{ "is-loading": pending }' ) Создать
b-card( title="Менеджеры" )
	b-table( :columns='columns' :data='users' :loading='pending' )
		template( #root='{ item }' )
			template( v-if='item.root' )
				span.icon.has-text-success
					i.fa-solid.fa-check-square
			template( v-else )
				span.icon.has-text-danger
					i.fa-solid.fa-xmark-square
		template( #remove='{ item }' )
			.button.is-small.is-danger( @click='remove(item.id)' )
				i.fa-solid.fa-trash-can
</template>

<script setup>
import BField from "@/components/form/Field.vue"
import BFields from "@/components/form/Fields.vue"
import BInput from "@/components/form/Input.vue"
import BCheckbox from "@/components/form/Checkbox.vue"
import BTable from "@/components/table/Table.vue"

import { computed, onMounted, ref } from "vue"

import { useUserStore } from "@/stores/user"

const columns = [
	{
		label: "Имя пользователя",
		field: "username"
	},
	{
		label: "Является админом",
		field: "root"
	},
	{
		field: "remove"
	}
]

const us = useUserStore()

const username = ref("")
const password = ref("")
const root = ref(false)
const pending = ref(false)

const users = computed(() => us.users)

const submit = async () => {
	if (pending.value) return

	pending.value = true

	try {
		await us.createUser({ username: username.value, password: password.value, root: root.value })
		username.value = ""
		password.value = ""
		root.value = false
		await us.getUsers()
	} catch(err) {
		console.error(err)
	}

	pending.value = false
}

const remove = async id => {
	pending.value = true
	try {
		await us.deleteUser(id)
		await us.getUsers()
	} catch(err) {
		console.error(err)
	}
	pending.value = false
}

onMounted(us.getUsers)
</script>

<style lang="scss" scoped>

</style>